/* A recursive-descent parser generated by peg 0.1.15 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define YYRULECOUNT 31


#include <glib.h>
#include <balde-template/parser-private.h>

#define YY_INPUT(buf, result, max_size)                          \
{                                                                \
    int yyc = (charbuf && *charbuf != '\0') ? *charbuf++ : EOF;  \
    result = (EOF == yyc) ? 0 : (*buf = yyc, 1);                 \
}

static GSList *nodes = NULL;
static gchar *fn_name = NULL;
static GSList *fn_args = NULL;
static balde_template_fn_arg_type_t fn_arg_type;
static const gchar *charbuf = NULL;

static void
balde_template_include_block(const gchar *include)
{
    balde_template_include_block_t *block = g_new(balde_template_include_block_t, 1);
    block->include = g_strdup(include);
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_INCLUDE_BLOCK;
    nodes = g_slist_append(nodes, node);
}

static void
balde_template_content_block(const gchar *content)
{
    balde_template_content_block_t *block = g_new(balde_template_content_block_t, 1);
    block->content = g_strdup(content);
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_CONTENT_BLOCK;
    nodes = g_slist_append(nodes, node);
}

static void
balde_template_print_var_block(const gchar *var)
{
    balde_template_print_var_block_t *block = g_new(balde_template_print_var_block_t, 1);
    block->variable = g_strdup(var);
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_PRINT_VAR_BLOCK;
    nodes = g_slist_append(nodes, node);
}

static void
balde_template_print_fn_arg(const gchar *arg)
{
    balde_template_fn_arg_t *a = g_new(balde_template_fn_arg_t, 1);
    a->content = g_strdup(arg);
    a->type = fn_arg_type;
    fn_args = g_slist_append(fn_args, a);
}

static void
balde_template_print_fn_id(const gchar *fn_id)
{
    fn_name = g_strdup(fn_id);
}

static void
balde_template_print_block(void)
{
    balde_template_print_fn_call_block_t *block = g_new(balde_template_print_fn_call_block_t, 1);
    block->name = fn_name;
    block->args = fn_args;
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_PRINT_FN_CALL_BLOCK;
    nodes = g_slist_append(nodes, node);
    fn_name = NULL;
    fn_args = NULL;
}


#ifndef YY_MALLOC
#define YY_MALLOC(C, N)		malloc(N)
#endif
#ifndef YY_REALLOC
#define YY_REALLOC(C, P, N)	realloc(P, N)
#endif
#ifndef YY_FREE
#define YY_FREE(C, P)		free(P)
#endif
#ifndef YY_LOCAL
#define YY_LOCAL(T)	static T
#endif
#ifndef YY_ACTION
#define YY_ACTION(T)	static T
#endif
#ifndef YY_RULE
#define YY_RULE(T)	static T
#endif
#ifndef YY_PARSE
#define YY_PARSE(T)	T
#endif
#ifndef YYPARSE
#define YYPARSE		yyparse
#endif
#ifndef YYPARSEFROM
#define YYPARSEFROM	yyparsefrom
#endif
#ifndef YYRELEASE
#define YYRELEASE	yyrelease
#endif
#ifndef YY_BEGIN
#define YY_BEGIN	( yy->__begin= yy->__pos, 1)
#endif
#ifndef YY_END
#define YY_END		( yy->__end= yy->__pos, 1)
#endif
#ifdef YY_DEBUG
# define yyprintf(args)	fprintf args
#else
# define yyprintf(args)
#endif
#ifndef YYSTYPE
#define YYSTYPE	int
#endif
#ifndef YY_STACK_SIZE
#define YY_STACK_SIZE 128
#endif

#ifndef YY_BUFFER_SIZE
#define YY_BUFFER_SIZE 1024
#endif

#ifndef YY_PART

typedef struct _yycontext yycontext;
typedef void (*yyaction)(yycontext *yy, char *yytext, int yyleng);
typedef struct _yythunk { int begin, end;  yyaction  action;  struct _yythunk *next; } yythunk;

struct _yycontext {
  char     *__buf;
  int       __buflen;
  int       __pos;
  int       __limit;
  char     *__text;
  int       __textlen;
  int       __begin;
  int       __end;
  int       __textmax;
  yythunk  *__thunks;
  int       __thunkslen;
  int       __thunkpos;
  YYSTYPE   __;
  YYSTYPE  *__val;
  YYSTYPE  *__vals;
  int       __valslen;
#ifdef YY_CTX_MEMBERS
  YY_CTX_MEMBERS
#endif
};

#ifdef YY_CTX_LOCAL
#define YY_CTX_PARAM_	yycontext *yyctx,
#define YY_CTX_PARAM	yycontext *yyctx
#define YY_CTX_ARG_	yyctx,
#define YY_CTX_ARG	yyctx
#ifndef YY_INPUT
#define YY_INPUT(yy, buf, result, max_size)		\
  {							\
    int yyc= getchar();					\
    result= (EOF == yyc) ? 0 : (*(buf)= yyc, 1);	\
    yyprintf((stderr, "<%c>", yyc));			\
  }
#endif
#else
#define YY_CTX_PARAM_
#define YY_CTX_PARAM
#define YY_CTX_ARG_
#define YY_CTX_ARG
yycontext _yyctx= { 0, 0 };
yycontext *yyctx= &_yyctx;
#ifndef YY_INPUT
#define YY_INPUT(buf, result, max_size)			\
  {							\
    int yyc= getchar();					\
    result= (EOF == yyc) ? 0 : (*(buf)= yyc, 1);	\
    yyprintf((stderr, "<%c>", yyc));			\
  }
#endif
#endif

YY_LOCAL(int) yyrefill(yycontext *yy)
{
  int yyn;
  while (yy->__buflen - yy->__pos < 512)
    {
      yy->__buflen *= 2;
      yy->__buf= (char *)YY_REALLOC(yy, yy->__buf, yy->__buflen);
    }
#ifdef YY_CTX_LOCAL
  YY_INPUT(yy, (yy->__buf + yy->__pos), yyn, (yy->__buflen - yy->__pos));
#else
  YY_INPUT((yy->__buf + yy->__pos), yyn, (yy->__buflen - yy->__pos));
#endif
  if (!yyn) return 0;
  yy->__limit += yyn;
  return 1;
}

YY_LOCAL(int) yymatchDot(yycontext *yy)
{
  if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
  ++yy->__pos;
  return 1;
}

YY_LOCAL(int) yymatchChar(yycontext *yy, int c)
{
  if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
  if ((unsigned char)yy->__buf[yy->__pos] == c)
    {
      ++yy->__pos;
      yyprintf((stderr, "  ok   yymatchChar(yy, %c) @ %s\n", c, yy->__buf+yy->__pos));
      return 1;
    }
  yyprintf((stderr, "  fail yymatchChar(yy, %c) @ %s\n", c, yy->__buf+yy->__pos));
  return 0;
}

YY_LOCAL(int) yymatchString(yycontext *yy, const char *s)
{
  int yysav= yy->__pos;
  while (*s)
    {
      if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
      if (yy->__buf[yy->__pos] != *s)
        {
          yy->__pos= yysav;
          return 0;
        }
      ++s;
      ++yy->__pos;
    }
  return 1;
}

YY_LOCAL(int) yymatchClass(yycontext *yy, unsigned char *bits)
{
  int c;
  if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
  c= (unsigned char)yy->__buf[yy->__pos];
  if (bits[c >> 3] & (1 << (c & 7)))
    {
      ++yy->__pos;
      yyprintf((stderr, "  ok   yymatchClass @ %s\n", yy->__buf+yy->__pos));
      return 1;
    }
  yyprintf((stderr, "  fail yymatchClass @ %s\n", yy->__buf+yy->__pos));
  return 0;
}

YY_LOCAL(void) yyDo(yycontext *yy, yyaction action, int begin, int end)
{
  while (yy->__thunkpos >= yy->__thunkslen)
    {
      yy->__thunkslen *= 2;
      yy->__thunks= (yythunk *)YY_REALLOC(yy, yy->__thunks, sizeof(yythunk) * yy->__thunkslen);
    }
  yy->__thunks[yy->__thunkpos].begin=  begin;
  yy->__thunks[yy->__thunkpos].end=    end;
  yy->__thunks[yy->__thunkpos].action= action;
  ++yy->__thunkpos;
}

YY_LOCAL(int) yyText(yycontext *yy, int begin, int end)
{
  int yyleng= end - begin;
  if (yyleng <= 0)
    yyleng= 0;
  else
    {
      while (yy->__textlen < (yyleng + 1))
	{
	  yy->__textlen *= 2;
	  yy->__text= (char *)YY_REALLOC(yy, yy->__text, yy->__textlen);
	}
      memcpy(yy->__text, yy->__buf + begin, yyleng);
    }
  yy->__text[yyleng]= '\0';
  return yyleng;
}

YY_LOCAL(void) yyDone(yycontext *yy)
{
  int pos;
  for (pos= 0;  pos < yy->__thunkpos;  ++pos)
    {
      yythunk *thunk= &yy->__thunks[pos];
      int yyleng= thunk->end ? yyText(yy, thunk->begin, thunk->end) : thunk->begin;
      yyprintf((stderr, "DO [%d] %p %s\n", pos, thunk->action, yy->__text));
      thunk->action(yy, yy->__text, yyleng);
    }
  yy->__thunkpos= 0;
}

YY_LOCAL(void) yyCommit(yycontext *yy)
{
  if ((yy->__limit -= yy->__pos))
    {
      memmove(yy->__buf, yy->__buf + yy->__pos, yy->__limit);
    }
  yy->__begin -= yy->__pos;
  yy->__end -= yy->__pos;
  yy->__pos= yy->__thunkpos= 0;
}

YY_LOCAL(int) yyAccept(yycontext *yy, int tp0)
{
  if (tp0)
    {
      fprintf(stderr, "accept denied at %d\n", tp0);
      return 0;
    }
  else
    {
      yyDone(yy);
      yyCommit(yy);
    }
  return 1;
}

YY_LOCAL(void) yyPush(yycontext *yy, char *text, int count)
{
  yy->__val += count;
  while (yy->__valslen <= yy->__val - yy->__vals)
    {
      long offset= yy->__val - yy->__vals;
      yy->__valslen *= 2;
      yy->__vals= (YYSTYPE *)YY_REALLOC(yy, yy->__vals, sizeof(YYSTYPE) * yy->__valslen);
      yy->__val= yy->__vals + offset;
    }
}
YY_LOCAL(void) yyPop(yycontext *yy, char *text, int count)   { yy->__val -= count; }
YY_LOCAL(void) yySet(yycontext *yy, char *text, int count)   { yy->__val[count]= yy->__; }

#endif /* YY_PART */

#define	YYACCEPT	yyAccept(yy, yythunkpos0)

YY_RULE(int) yy_print_fn(yycontext *yy); /* 31 */
YY_RULE(int) yy_print_fn_id(yycontext *yy); /* 30 */
YY_RULE(int) yy_print_fn_args(yycontext *yy); /* 29 */
YY_RULE(int) yy_print_fn_arg(yycontext *yy); /* 28 */
YY_RULE(int) yy_print_fn_arg_null(yycontext *yy); /* 27 */
YY_RULE(int) yy_print_fn_arg_bool(yycontext *yy); /* 26 */
YY_RULE(int) yy_print_fn_arg_float(yycontext *yy); /* 25 */
YY_RULE(int) yy_print_fn_arg_int(yycontext *yy); /* 24 */
YY_RULE(int) yy_print_fn_arg_str(yycontext *yy); /* 23 */
YY_RULE(int) yy_print_fn_arg_var(yycontext *yy); /* 22 */
YY_RULE(int) yy_print_var(yycontext *yy); /* 21 */
YY_RULE(int) yy_print_close(yycontext *yy); /* 20 */
YY_RULE(int) yy_print_open(yycontext *yy); /* 19 */
YY_RULE(int) yy_include_close(yycontext *yy); /* 18 */
YY_RULE(int) yy_include_open(yycontext *yy); /* 17 */
YY_RULE(int) yy_null(yycontext *yy); /* 16 */
YY_RULE(int) yy_bool(yycontext *yy); /* 15 */
YY_RULE(int) yy_float(yycontext *yy); /* 14 */
YY_RULE(int) yy_sign(yycontext *yy); /* 13 */
YY_RULE(int) yy_int(yycontext *yy); /* 12 */
YY_RULE(int) yy_str(yycontext *yy); /* 11 */
YY_RULE(int) yy_unq_str(yycontext *yy); /* 10 */
YY_RULE(int) yy_id(yycontext *yy); /* 9 */
YY_RULE(int) yy__(yycontext *yy); /* 8 */
YY_RULE(int) yy_eof(yycontext *yy); /* 7 */
YY_RULE(int) yy_eol(yycontext *yy); /* 6 */
YY_RULE(int) yy_anything(yycontext *yy); /* 5 */
YY_RULE(int) yy_content(yycontext *yy); /* 4 */
YY_RULE(int) yy_print_call(yycontext *yy); /* 3 */
YY_RULE(int) yy_include(yycontext *yy); /* 2 */
YY_RULE(int) yy_page(yycontext *yy); /* 1 */

YY_ACTION(void) yy_1_content(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_content\n"));
  {
   balde_template_content_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn\n"));
  {
   balde_template_print_block(); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_id(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_id\n"));
  {
   balde_template_print_fn_id(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg\n"));
  {
   balde_template_print_fn_arg(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_null(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_null\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_NULL; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_bool(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_bool\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_BOOL; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_float(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_float\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_FLOAT; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_int(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_int\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_INT; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_str(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_str\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_STRING; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_var(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_var\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_VAR; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_var(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_var\n"));
  {
   balde_template_print_var_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_include(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_include\n"));
  {
   balde_template_include_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_page(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_page\n"));
  {
   g_printerr("Syntax error near: %s\n", yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}

YY_RULE(int) yy_print_fn(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn"));  if (!yy_print_fn_id(yy)) goto l1;  if (!yy__(yy)) goto l1;  if (!yymatchChar(yy, '(')) goto l1;  if (!yy_print_fn_args(yy)) goto l1;  if (!yymatchChar(yy, ')')) goto l1;  yyDo(yy, yy_1_print_fn, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn", yy->__buf+yy->__pos));
  return 1;
  l1:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_id(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_id"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l2;
#undef yytext
#undef yyleng
  }  if (!yy_id(yy)) goto l2;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l2;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_id, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_id", yy->__buf+yy->__pos));
  return 1;
  l2:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_id", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_args(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_args"));  if (!yy__(yy)) goto l3;
  l4:;	
  {  int yypos5= yy->__pos, yythunkpos5= yy->__thunkpos;  if (!yy_print_fn_arg(yy)) goto l5;
  l6:;	
  {  int yypos7= yy->__pos, yythunkpos7= yy->__thunkpos;  if (!yy__(yy)) goto l7;  if (!yymatchChar(yy, ',')) goto l7;  if (!yy__(yy)) goto l7;  if (!yy_print_fn_arg(yy)) goto l7;  goto l6;
  l7:;	  yy->__pos= yypos7; yy->__thunkpos= yythunkpos7;
  }  if (!yy__(yy)) goto l5;  goto l4;
  l5:;	  yy->__pos= yypos5; yy->__thunkpos= yythunkpos5;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_args", yy->__buf+yy->__pos));
  return 1;
  l3:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_args", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l8;
#undef yytext
#undef yyleng
  }
  {  int yypos9= yy->__pos, yythunkpos9= yy->__thunkpos;  if (!yy_print_fn_arg_bool(yy)) goto l10;  goto l9;
  l10:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_null(yy)) goto l11;  goto l9;
  l11:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_float(yy)) goto l12;  goto l9;
  l12:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_int(yy)) goto l13;  goto l9;
  l13:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_var(yy)) goto l14;  goto l9;
  l14:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_str(yy)) goto l8;
  }
  l9:;	  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l8;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_arg, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg", yy->__buf+yy->__pos));
  return 1;
  l8:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_null(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_null"));  if (!yy_null(yy)) goto l15;  yyDo(yy, yy_1_print_fn_arg_null, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_null", yy->__buf+yy->__pos));
  return 1;
  l15:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_null", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_bool(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_bool"));  if (!yy_bool(yy)) goto l16;  yyDo(yy, yy_1_print_fn_arg_bool, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_bool", yy->__buf+yy->__pos));
  return 1;
  l16:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_bool", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_float(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_float"));  if (!yy_float(yy)) goto l17;  yyDo(yy, yy_1_print_fn_arg_float, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_float", yy->__buf+yy->__pos));
  return 1;
  l17:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_float", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_int(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_int"));  if (!yy_int(yy)) goto l18;  yyDo(yy, yy_1_print_fn_arg_int, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_int", yy->__buf+yy->__pos));
  return 1;
  l18:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_int", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_str(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_str"));  if (!yy_str(yy)) goto l19;  yyDo(yy, yy_1_print_fn_arg_str, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_str", yy->__buf+yy->__pos));
  return 1;
  l19:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_str", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_var(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_var"));  if (!yy_id(yy)) goto l20;  yyDo(yy, yy_1_print_fn_arg_var, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_var", yy->__buf+yy->__pos));
  return 1;
  l20:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_var", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_var(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_var"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l21;
#undef yytext
#undef yyleng
  }  if (!yy_id(yy)) goto l21;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l21;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_var, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_var", yy->__buf+yy->__pos));
  return 1;
  l21:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_var", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_close(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_close"));  if (!yy__(yy)) goto l22;  if (!yymatchString(yy, "}}")) goto l22;
  yyprintf((stderr, "  ok   %s @ %s\n", "print_close", yy->__buf+yy->__pos));
  return 1;
  l22:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_close", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_open(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_open"));  if (!yymatchString(yy, "{{")) goto l23;  if (!yy__(yy)) goto l23;
  yyprintf((stderr, "  ok   %s @ %s\n", "print_open", yy->__buf+yy->__pos));
  return 1;
  l23:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_open", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_include_close(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "include_close"));  if (!yy__(yy)) goto l24;  if (!yymatchString(yy, "%}")) goto l24;
  yyprintf((stderr, "  ok   %s @ %s\n", "include_close", yy->__buf+yy->__pos));
  return 1;
  l24:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "include_close", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_include_open(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "include_open"));  if (!yymatchString(yy, "{%")) goto l25;  if (!yy__(yy)) goto l25;
  yyprintf((stderr, "  ok   %s @ %s\n", "include_open", yy->__buf+yy->__pos));
  return 1;
  l25:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "include_open", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_null(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "null"));  if (!yymatchString(yy, "NULL")) goto l26;
  yyprintf((stderr, "  ok   %s @ %s\n", "null", yy->__buf+yy->__pos));
  return 1;
  l26:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "null", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_bool(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "bool"));
  {  int yypos28= yy->__pos, yythunkpos28= yy->__thunkpos;  if (!yymatchString(yy, "TRUE")) goto l29;  goto l28;
  l29:;	  yy->__pos= yypos28; yy->__thunkpos= yythunkpos28;  if (!yymatchString(yy, "FALSE")) goto l27;
  }
  l28:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "bool", yy->__buf+yy->__pos));
  return 1;
  l27:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "bool", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_float(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "float"));
  {  int yypos31= yy->__pos, yythunkpos31= yy->__thunkpos;  if (!yy_sign(yy)) goto l31;  goto l32;
  l31:;	  yy->__pos= yypos31; yy->__thunkpos= yythunkpos31;
  }
  l32:;	  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l30;
  l33:;	
  {  int yypos34= yy->__pos, yythunkpos34= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l34;  goto l33;
  l34:;	  yy->__pos= yypos34; yy->__thunkpos= yythunkpos34;
  }  if (!yymatchChar(yy, '.')) goto l30;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l30;
  l35:;	
  {  int yypos36= yy->__pos, yythunkpos36= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l36;  goto l35;
  l36:;	  yy->__pos= yypos36; yy->__thunkpos= yythunkpos36;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "float", yy->__buf+yy->__pos));
  return 1;
  l30:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "float", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_sign(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "sign"));
  {  int yypos38= yy->__pos, yythunkpos38= yy->__thunkpos;  if (!yymatchChar(yy, '+')) goto l39;  goto l38;
  l39:;	  yy->__pos= yypos38; yy->__thunkpos= yythunkpos38;  if (!yymatchChar(yy, '-')) goto l37;
  }
  l38:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "sign", yy->__buf+yy->__pos));
  return 1;
  l37:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "sign", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_int(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "int"));
  {  int yypos41= yy->__pos, yythunkpos41= yy->__thunkpos;  if (!yy_sign(yy)) goto l41;  goto l42;
  l41:;	  yy->__pos= yypos41; yy->__thunkpos= yythunkpos41;
  }
  l42:;	  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l40;
  l43:;	
  {  int yypos44= yy->__pos, yythunkpos44= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l44;  goto l43;
  l44:;	  yy->__pos= yypos44; yy->__thunkpos= yythunkpos44;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "int", yy->__buf+yy->__pos));
  return 1;
  l40:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "int", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_str(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "str"));  if (!yymatchChar(yy, '"')) goto l45;  if (!yy_unq_str(yy)) goto l45;  if (!yymatchChar(yy, '"')) goto l45;
  yyprintf((stderr, "  ok   %s @ %s\n", "str", yy->__buf+yy->__pos));
  return 1;
  l45:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "str", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_unq_str(yycontext *yy)
{
  yyprintf((stderr, "%s\n", "unq_str"));
  l47:;	
  {  int yypos48= yy->__pos, yythunkpos48= yy->__thunkpos;
  {  int yypos49= yy->__pos, yythunkpos49= yy->__thunkpos;  if (!yymatchChar(yy, '\\')) goto l50;  if (!yymatchChar(yy, '"')) goto l50;  goto l49;
  l50:;	  yy->__pos= yypos49; yy->__thunkpos= yythunkpos49;
  {  int yypos51= yy->__pos, yythunkpos51= yy->__thunkpos;  if (!yymatchChar(yy, '"')) goto l51;  goto l48;
  l51:;	  yy->__pos= yypos51; yy->__thunkpos= yythunkpos51;
  }  if (!yymatchDot(yy)) goto l48;
  }
  l49:;	  goto l47;
  l48:;	  yy->__pos= yypos48; yy->__thunkpos= yythunkpos48;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "unq_str", yy->__buf+yy->__pos));
  return 1;
}
YY_RULE(int) yy_id(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "id"));  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l52;
  l53:;	
  {  int yypos54= yy->__pos, yythunkpos54= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\376\377\377\207\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l54;  goto l53;
  l54:;	  yy->__pos= yypos54; yy->__thunkpos= yythunkpos54;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "id", yy->__buf+yy->__pos));
  return 1;
  l52:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "id", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy__(yycontext *yy)
{
  yyprintf((stderr, "%s\n", "_"));
  l56:;	
  {  int yypos57= yy->__pos, yythunkpos57= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\002\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l57;  goto l56;
  l57:;	  yy->__pos= yypos57; yy->__thunkpos= yythunkpos57;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "_", yy->__buf+yy->__pos));
  return 1;
}
YY_RULE(int) yy_eof(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "eof"));
  {  int yypos59= yy->__pos, yythunkpos59= yy->__thunkpos;  if (!yymatchDot(yy)) goto l59;  goto l58;
  l59:;	  yy->__pos= yypos59; yy->__thunkpos= yythunkpos59;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "eof", yy->__buf+yy->__pos));
  return 1;
  l58:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "eof", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_eol(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "eol"));
  {  int yypos61= yy->__pos, yythunkpos61= yy->__thunkpos;  if (!yymatchChar(yy, '\n')) goto l62;  goto l61;
  l62:;	  yy->__pos= yypos61; yy->__thunkpos= yythunkpos61;  if (!yymatchString(yy, "\r\n")) goto l63;  goto l61;
  l63:;	  yy->__pos= yypos61; yy->__thunkpos= yythunkpos61;  if (!yymatchChar(yy, '\r')) goto l60;
  }
  l61:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "eol", yy->__buf+yy->__pos));
  return 1;
  l60:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "eol", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_anything(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "anything"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l64;
#undef yytext
#undef yyleng
  }
  l65:;	
  {  int yypos66= yy->__pos, yythunkpos66= yy->__thunkpos;
  {  int yypos67= yy->__pos, yythunkpos67= yy->__thunkpos;  if (!yy_eol(yy)) goto l67;  goto l66;
  l67:;	  yy->__pos= yypos67; yy->__thunkpos= yythunkpos67;
  }  if (!yymatchDot(yy)) goto l66;  goto l65;
  l66:;	  yy->__pos= yypos66; yy->__thunkpos= yythunkpos66;
  }  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l64;
#undef yytext
#undef yyleng
  }  if (!yy_eol(yy)) goto l64;
  yyprintf((stderr, "  ok   %s @ %s\n", "anything", yy->__buf+yy->__pos));
  return 1;
  l64:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "anything", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_content(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "content"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l68;
#undef yytext
#undef yyleng
  }
  {  int yypos71= yy->__pos, yythunkpos71= yy->__thunkpos;  if (!yy_eof(yy)) goto l71;  goto l68;
  l71:;	  yy->__pos= yypos71; yy->__thunkpos= yythunkpos71;
  }
  {  int yypos72= yy->__pos, yythunkpos72= yy->__thunkpos;  if (!yy_include_open(yy)) goto l72;  goto l68;
  l72:;	  yy->__pos= yypos72; yy->__thunkpos= yythunkpos72;
  }
  {  int yypos73= yy->__pos, yythunkpos73= yy->__thunkpos;  if (!yy_include_close(yy)) goto l73;  goto l68;
  l73:;	  yy->__pos= yypos73; yy->__thunkpos= yythunkpos73;
  }
  {  int yypos74= yy->__pos, yythunkpos74= yy->__thunkpos;  if (!yy_print_open(yy)) goto l74;  goto l68;
  l74:;	  yy->__pos= yypos74; yy->__thunkpos= yythunkpos74;
  }
  {  int yypos75= yy->__pos, yythunkpos75= yy->__thunkpos;  if (!yy_print_close(yy)) goto l75;  goto l68;
  l75:;	  yy->__pos= yypos75; yy->__thunkpos= yythunkpos75;
  }  if (!yymatchDot(yy)) goto l68;
  l69:;	
  {  int yypos70= yy->__pos, yythunkpos70= yy->__thunkpos;
  {  int yypos76= yy->__pos, yythunkpos76= yy->__thunkpos;  if (!yy_eof(yy)) goto l76;  goto l70;
  l76:;	  yy->__pos= yypos76; yy->__thunkpos= yythunkpos76;
  }
  {  int yypos77= yy->__pos, yythunkpos77= yy->__thunkpos;  if (!yy_include_open(yy)) goto l77;  goto l70;
  l77:;	  yy->__pos= yypos77; yy->__thunkpos= yythunkpos77;
  }
  {  int yypos78= yy->__pos, yythunkpos78= yy->__thunkpos;  if (!yy_include_close(yy)) goto l78;  goto l70;
  l78:;	  yy->__pos= yypos78; yy->__thunkpos= yythunkpos78;
  }
  {  int yypos79= yy->__pos, yythunkpos79= yy->__thunkpos;  if (!yy_print_open(yy)) goto l79;  goto l70;
  l79:;	  yy->__pos= yypos79; yy->__thunkpos= yythunkpos79;
  }
  {  int yypos80= yy->__pos, yythunkpos80= yy->__thunkpos;  if (!yy_print_close(yy)) goto l80;  goto l70;
  l80:;	  yy->__pos= yypos80; yy->__thunkpos= yythunkpos80;
  }  if (!yymatchDot(yy)) goto l70;  goto l69;
  l70:;	  yy->__pos= yypos70; yy->__thunkpos= yythunkpos70;
  }  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l68;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_content, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "content", yy->__buf+yy->__pos));
  return 1;
  l68:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "content", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_call(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_call"));  if (!yy_print_open(yy)) goto l81;
  {  int yypos82= yy->__pos, yythunkpos82= yy->__thunkpos;  if (!yy_print_fn(yy)) goto l83;  goto l82;
  l83:;	  yy->__pos= yypos82; yy->__thunkpos= yythunkpos82;  if (!yy_print_var(yy)) goto l81;
  }
  l82:;	  if (!yy_print_close(yy)) goto l81;
  yyprintf((stderr, "  ok   %s @ %s\n", "print_call", yy->__buf+yy->__pos));
  return 1;
  l81:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_call", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_include(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "include"));  if (!yy_include_open(yy)) goto l84;  if (!yymatchString(yy, "include")) goto l84;  if (!yymatchChar(yy, ' ')) goto l84;
  l85:;	
  {  int yypos86= yy->__pos, yythunkpos86= yy->__thunkpos;  if (!yymatchChar(yy, ' ')) goto l86;  goto l85;
  l86:;	  yy->__pos= yypos86; yy->__thunkpos= yythunkpos86;
  }  if (!yymatchChar(yy, '"')) goto l84;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l84;
#undef yytext
#undef yyleng
  }  if (!yy_unq_str(yy)) goto l84;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l84;
#undef yytext
#undef yyleng
  }  if (!yymatchChar(yy, '"')) goto l84;  if (!yy_include_close(yy)) goto l84;  yyDo(yy, yy_1_include, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "include", yy->__buf+yy->__pos));
  return 1;
  l84:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "include", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_page(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "page"));
  {  int yypos88= yy->__pos, yythunkpos88= yy->__thunkpos;  if (!yy_include(yy)) goto l89;  goto l88;
  l89:;	  yy->__pos= yypos88; yy->__thunkpos= yythunkpos88;  if (!yy_print_call(yy)) goto l90;  goto l88;
  l90:;	  yy->__pos= yypos88; yy->__thunkpos= yythunkpos88;  if (!yy_content(yy)) goto l91;  goto l88;
  l91:;	  yy->__pos= yypos88; yy->__thunkpos= yythunkpos88;  if (!yy_anything(yy)) goto l87;  yyDo(yy, yy_1_page, yy->__begin, yy->__end);
  }
  l88:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "page", yy->__buf+yy->__pos));
  return 1;
  l87:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "page", yy->__buf+yy->__pos));
  return 0;
}

#ifndef YY_PART

typedef int (*yyrule)(yycontext *yy);

YY_PARSE(int) YYPARSEFROM(YY_CTX_PARAM_ yyrule yystart)
{
  int yyok;
  if (!yyctx->__buflen)
    {
      yyctx->__buflen= YY_BUFFER_SIZE;
      yyctx->__buf= (char *)YY_MALLOC(yyctx, yyctx->__buflen);
      yyctx->__textlen= YY_BUFFER_SIZE;
      yyctx->__text= (char *)YY_MALLOC(yyctx, yyctx->__textlen);
      yyctx->__thunkslen= YY_STACK_SIZE;
      yyctx->__thunks= (yythunk *)YY_MALLOC(yyctx, sizeof(yythunk) * yyctx->__thunkslen);
      yyctx->__valslen= YY_STACK_SIZE;
      yyctx->__vals= (YYSTYPE *)YY_MALLOC(yyctx, sizeof(YYSTYPE) * yyctx->__valslen);
      yyctx->__begin= yyctx->__end= yyctx->__pos= yyctx->__limit= yyctx->__thunkpos= 0;
    }
  yyctx->__begin= yyctx->__end= yyctx->__pos;
  yyctx->__thunkpos= 0;
  yyctx->__val= yyctx->__vals;
  yyok= yystart(yyctx);
  if (yyok) yyDone(yyctx);
  yyCommit(yyctx);
  return yyok;
}

YY_PARSE(int) YYPARSE(YY_CTX_PARAM)
{
  return YYPARSEFROM(YY_CTX_ARG_ yy_page);
}

YY_PARSE(yycontext *) YYRELEASE(yycontext *yyctx)
{
  if (yyctx->__buflen)
    {
      yyctx->__buflen= 0;
      YY_FREE(yyctx, yyctx->__buf);
      YY_FREE(yyctx, yyctx->__text);
      YY_FREE(yyctx, yyctx->__thunks);
      YY_FREE(yyctx, yyctx->__vals);
    }
  return yyctx;
}

#endif


GSList*
balde_template_parse(const gchar *tmpl)
{
    charbuf = tmpl;
    while(yyparse());
    GSList *rv = nodes;
    charbuf = NULL;
    nodes = NULL;
    return rv;
}

